(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2005 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  odstranny podmnn peklady pro MS-DOS (P92)
2)  pechod na 32 bit: longint nahrazen typem integer, zjednodueno (P92)
3)  parametr WriteStr zmnn na const (P93)
4)  MaxToolCount rozen na 300, aby pokryl zven poet logickch typ (P96)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

UNIT DLL_Util;

INTERFACE

USES DrvTypes;

CONST MaxToolCount = 300;

VAR WorkToolTable: array [0..MaxToolCount] of ToolDescr_T;

VAR Write: WriteProc_T;

procedure WriteStr (const S: string);

procedure WriteByte (B: byte);

procedure WriteWord (W: word);

function EvenParity (c: char): char;

function OddParity (c: char): char;

function IntStr (N: integer): string;

function ARIntStr (N, Width: integer): string;

function LZIntStr (N, Width: integer): string;

IMPLEMENTATION // ==============================================================

procedure WriteStr (const S: string);
begin
  Write (PChar (@S) [1], Length (S));
end;

procedure WriteByte (B: byte);
begin
  Write (B, SizeOf (B));
end;

procedure WriteWord (W: word);
begin
  Write (W, SizeOf (W));
end;

function EvenParity (c: char): char;
asm
        and AL, AL
        jpe @Even
        or  AL, $80
  @Even:
end;

function OddParity (c: char): char;
asm
        and AL, AL
        jpo @Odd
        or  AL, $80
  @Odd:
end;

function IntStr (N: integer): string;
begin
  Str (N, Result);
end;

function ARIntStr (N, Width: integer): string;
begin
  Str (N: Width, Result);
end;

function LZIntStr (N, Width: integer): string;
  var i: integer;
begin
  Str (Abs (N): Width, Result);
  for i := 1 to Length (Result) do
    if Result [i] = ' ' then Result [i] := '0';  {add leading zeroes}
  if N < 0 then Result := '-' + Result;
end;

END.
