(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2004 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  funkce GetDescrPtr pejmenovna pro rozlien verz na GetDescrPtr440 (P93)
2)  do funkce OpenLayer doplnn parametr Color (P93)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

LIBRARY Gerber;

USES DrvTypes, DLL_Util;

TYPE
  ParamIndex_T = (
    NoOfDigits,
    RepeatedCoordinates,
    EvenParityEnabled);

CONST
  ToolCount = 40;
  Both = [UsageDraw, UsageFlash];
  ToolTable: array [1..ToolCount] of ToolDescr_T = (
    (DescrStr: 'D11 (Circle  0.1  mm)'; Shape: CircleTool;  Width:  100; Height: 0; Usage: Both; Code: 11),
    (DescrStr: 'D12 (Circle  0.2  mm)'; Shape: CircleTool;  Width:  200; Height: 0; Usage: Both; Code: 12),
    (DescrStr: 'D13 (Circle  0.25 mm)'; Shape: CircleTool;  Width:  250; Height: 0; Usage: Both; Code: 13),
    (DescrStr: 'D14 (Circle  0.3  mm)'; Shape: CircleTool;  Width:  300; Height: 0; Usage: Both; Code: 14),
    (DescrStr: 'D16 (Circle  0.4  mm)'; Shape: CircleTool;  Width:  400; Height: 0; Usage: Both; Code: 16),
    (DescrStr: 'D17 (Circle  0.5  mm)'; Shape: CircleTool;  Width:  500; Height: 0; Usage: Both; Code: 17),
    (DescrStr: 'D18 (Circle  0.6  mm)'; Shape: CircleTool;  Width:  600; Height: 0; Usage: Both; Code: 18),
    (DescrStr: 'D19 (Circle  0.7  mm)'; Shape: CircleTool;  Width:  700; Height: 0; Usage: Both; Code: 19),
    (DescrStr: 'D21 (Circle  0.8  mm)'; Shape: CircleTool;  Width:  800; Height: 0; Usage: Both; Code: 21),
    (DescrStr: 'D22 (Circle  0.9  mm)'; Shape: CircleTool;  Width:  900; Height: 0; Usage: Both; Code: 22),
    (DescrStr: 'D23 (Circle  1.0  mm)'; Shape: CircleTool;  Width: 1000; Height: 0; Usage: Both; Code: 23),
    (DescrStr: 'D24 (Circle  1.1  mm)'; Shape: CircleTool;  Width: 1100; Height: 0; Usage: Both; Code: 24),
    (DescrStr: 'D26 (Circle  1.2  mm)'; Shape: CircleTool;  Width: 1200; Height: 0; Usage: Both; Code: 26),
    (DescrStr: 'D27 (Circle  1.3  mm)'; Shape: CircleTool;  Width: 1300; Height: 0; Usage: Both; Code: 27),
    (DescrStr: 'D28 (Circle  1.4  mm)'; Shape: CircleTool;  Width: 1400; Height: 0; Usage: Both; Code: 28),
    (DescrStr: 'D29 (Circle  1.5  mm)'; Shape: CircleTool;  Width: 1500; Height: 0; Usage: Both; Code: 29),
    (DescrStr: 'D31 (Circle  1.6  mm)'; Shape: CircleTool;  Width: 1600; Height: 0; Usage: Both; Code: 31),
    (DescrStr: 'D32 (Circle  1.7  mm)'; Shape: CircleTool;  Width: 1700; Height: 0; Usage: Both; Code: 32),
    (DescrStr: 'D33 (Circle  1.8  mm)'; Shape: CircleTool;  Width: 1800; Height: 0; Usage: Both; Code: 33),
    (DescrStr: 'D34 (Circle  2.0  mm)'; Shape: CircleTool;  Width: 2000; Height: 0; Usage: Both; Code: 34),
    (DescrStr: 'D36 (Circle  2.2  mm)'; Shape: CircleTool;  Width: 2200; Height: 0; Usage: Both; Code: 36),
    (DescrStr: 'D37 (Circle  2.4  mm)'; Shape: CircleTool;  Width: 2400; Height: 0; Usage: Both; Code: 37),
    (DescrStr: 'D38 (Circle  2.6  mm)'; Shape: CircleTool;  Width: 2600; Height: 0; Usage: Both; Code: 38),
    (DescrStr: 'D39 (Circle  2.8  mm)'; Shape: CircleTool;  Width: 2800; Height: 0; Usage: Both; Code: 39),
    (DescrStr: 'D41 (Circle  3.0  mm)'; Shape: CircleTool;  Width: 3000; Height: 0; Usage: Both; Code: 41),
    (DescrStr: 'D42 (Circle  3.2  mm)'; Shape: CircleTool;  Width: 3200; Height: 0; Usage: Both; Code: 42),
    (DescrStr: 'D43 (Circle  3.6  mm)'; Shape: CircleTool;  Width: 3600; Height: 0; Usage: Both; Code: 43),
    (DescrStr: 'D30 (Square  0.1  mm)'; Shape: SquareTool;  Width:  100; Height: 0; Usage: Both; Code: 30),
    (DescrStr: 'D40 (Square  0.2  mm)'; Shape: SquareTool;  Width:  200; Height: 0; Usage: Both; Code: 40),
    (DescrStr: 'D10 (Square  0.3  mm)'; Shape: SquareTool;  Width:  300; Height: 0; Usage: Both; Code: 10),
    (DescrStr: 'D20 (Square  0.4  mm)'; Shape: SquareTool;  Width:  400; Height: 0; Usage: Both; Code: 20),
    (DescrStr: 'D48 (Square  1.62 mm)'; Shape: SquareTool;  Width: 1620; Height: 0; Usage: Both; Code: 48),
    (DescrStr: 'D15 (Thermal 1.6  mm)'; Shape: ThermalTool; Width: 1600; Height: 0; Usage: Both; Code: 15),
    (DescrStr: 'D25 (Thermal 2.0  mm)'; Shape: ThermalTool; Width: 2000; Height: 0; Usage: Both; Code: 25),
    (DescrStr: 'D35 (Thermal 2.8  mm)'; Shape: ThermalTool; Width: 2800; Height: 0; Usage: Both; Code: 35),
    (DescrStr: 'D44 (Annulus 1.27 mm)'; Shape: AnnulusTool; Width: 1270; Height: 0; Usage: Both; Code: 44),
    (DescrStr: 'D45 (Annulus 1.6  mm)'; Shape: AnnulusTool; Width: 1600; Height: 0; Usage: Both; Code: 45),
    (DescrStr: 'D46 (Annulus 2.0  mm)'; Shape: AnnulusTool; Width: 2000; Height: 0; Usage: Both; Code: 46),
    (DescrStr: 'D47 (Annulus 2.8  mm)'; Shape: AnnulusTool; Width: 2800; Height: 0; Usage: Both; Code: 47),
    (DescrStr: 'D49 (Target  2.79 mm)'; Shape: SpecialTool; Width: 2790; Height: 0; Usage: Both; Code: 49));

  DriverDescr: DriverDescr_T = (
    Name:         'Gerber 4.0 PH 1994';
    MajorVersion: 4;
    MinorVersion: 0;
    Capabilities: [Optimizable, DrawLines, FlashPads];
    NoOfParams:   Ord (High (ParamIndex_T)) + 1;
    FilesName:    'Gerber';
    TargetExt:    '';
    NoOfTools:    ToolCount;
    InitialTools: @ ToolTable [1];
    MaxNoOfTools: MaxToolCount;
    ToolTablePtr: @ WorkToolTable;
    X0:           0;
    Y0:           0;
    X1:           800;
    Y1:           600;
    XDividend:    1000;
    YDividend:    1000;
    Divisor:      1);

  Params: array [ParamIndex_T] of ParamDescr_T = (
   (DescrStr:  '>Number of Digits';
    Value:     6;
    ParamType: _Numeric;
    MinVal:    1;
    MaxVal:    8),
   (DescrStr:  '>Repeated Coordinates';
    Value:     Ord (false);
    ParamType: _Explicite;
    Values:    '>Omitted|>Included'),
   (DescrStr:  '>Even Parity';
    Value:     Ord (false);
    ParamType: _Explicite;
    Values:    'Off|On'));

FUNCTION GetDescrPtr440: DescrPtr_T;
begin
  Result := @ DriverDescr;
end;

FUNCTION GetParamPtr (ParamNumber: integer): ParamPtr_T;
begin
  Result := @ Params [ParamIndex_T (ParamNumber)];
end;

PROCEDURE SetParamValue (ParamNumber: integer; ParamValue: integer);
begin
  Params [ParamIndex_T (ParamNumber)].Value := ParamValue;
end;

// -----------------------------------------------------------------------------

VAR
  CurrentX, CurrentY: DriverUnits_T;
  CurrentToolCode:    ToolCode_T;

procedure Output (AsciiString: string);
  var i: integer;
begin
  if Boolean (Params [EvenParityEnabled].Value) then
    for i := 1 to Length (AsciiString) do
      AsciiString [i] := EvenParity (AsciiString [i]);
  WriteStr (AsciiString);
end;

PROCEDURE OpenEquip (WriteProc: WriteProc_T; X0, Y0, X1, Y1: DriverUnits_T);
begin
  Write := WriteProc;
{ Output ('*'^M^J); }  (* ??? "*" snad je zbytecna *)
  CurrentX := MaxLongInt;   CurrentY := MaxLongInt;
  CurrentToolCode := MaxInt;
end;

PROCEDURE Comment (const CommentString: string);
begin
end;

PROCEDURE OpenLayer (Layer: integer; Color: integer = 0);
begin
end;

procedure ChangeAperture (ToolNumber: ToolNumber_T);
  var ToolCode: ToolCode_T;
begin
  ToolCode := WorkToolTable [ToolNumber].Code;
  if ToolCode <> CurrentToolCode then
    Output ('G54D' + LZIntStr (ToolCode, 2) + '*'^M^J);
  CurrentToolCode := ToolCode;
end;

procedure OutputCoordinates (X, Y: DriverUnits_T);
begin
  if Boolean (Params [RepeatedCoordinates].Value) or (X <> CurrentX) and (Y <> CurrentY) then
    Output ('X' + LZIntStr (X, Params [NoOfDigits].Value) { + ' ' + }
          + 'Y' + LZIntStr (Y, Params [NoOfDigits].Value))
  else if (X = CurrentX) then
    Output ('Y' + LZIntStr (Y, Params [NoOfDigits].Value))
  else
    Output ('X' + LZIntStr (X, Params [NoOfDigits].Value));
  CurrentX := X;
  CurrentY := Y;
end;

PROCEDURE DrawLine (X0, Y0, X1, Y1: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  ChangeAperture (ToolNumber);
  if (X0 <> CurrentX) or (Y0 <> CurrentY) then begin
    OutputCoordinates (X0, Y0);
    Output ('D02*'^M^J);
  end;
  OutputCoordinates (X1, Y1);
  Output ('D01*'^M^J);
end;

PROCEDURE FlashPad (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  ChangeAperture (ToolNumber);
  OutputCoordinates (X, Y);
  Output ('D03*'^M^J);
end;

PROCEDURE CloseEquip;
begin
  Output ('M02*'^M^J);
end;

EXPORTS
  GetDescrPtr440,
  GetParamPtr,
  SetParamValue,
  OpenEquip,
  Comment,
  OpenLayer,
  DrawLine,
  FlashPad,
  CloseEquip;

BEGIN
END.
