(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2005 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  funkce GetDescrPtr pejmenovna pro rozlien verz na GetDescrPtr440 (P93)
2)  do funkce OpenLayer doplnn parametr Color (P93)
3)  poet vrstev v menu doplnn do 24 (P96)
4)  defaultn extenze zmnna na .PLT (P96)
5)  doplnn parametr pro ku pera slo 2 (P96)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

LIBRARY HPGL_Plotter;

USES DrvTypes, DLL_Util;

TYPE
  ParamIndex_T = (
    Layer0,
    Layer1,
    Layer2,
    Layer3,
    Layer4,
    Layer5,
    Layer6,
    Layer7,
    Layer8,
    Layer9,
    Layer10,
    Layer11,
    Layer12,
    Layer13,
    Layer14,
    Layer15,
    Layer16,
    Layer17,
    Layer18,
    Layer19,
    Layer20,
    Layer21,
    Layer22,
    Layer23,
    Pen1Width,
    Pen2Width,
    OthersWidth,
    OverlapPar,
    FillElements,
    PenVelocity);

CONST
  ToolCount = 0;
  DriverDescr: DriverDescr_T = (
    Name:         'HP-GL Plotter';
    MajorVersion: 4;
    MinorVersion: 0;
    Capabilities: [Optimizable, DrawLines, FlashPads, ConfigTools, UserTools];
    NoOfParams:   Ord (High (ParamIndex_T)) + 1;
    FilesName:    'HPGL';
    TargetExt:    '.PLT';
    NoOfTools:    ToolCount;
    InitialTools: nil;
    MaxNoOfTools: MaxToolCount;
    ToolTablePtr: @ WorkToolTable;
    X0:           0;
    Y0:           0;
    X1:           800;
    Y1:           600;
    XDividend:    402;
    YDividend:    402;
    Divisor:      10);

  Pens = 'Pen >1|Pen >2|Pen >3|Pen >4|Pen >5|Pen >6|Pen >7|Pen >8';

  Params: array [ParamIndex_T] of ParamDescr_T = (
   (DescrStr:  'Layer >0 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >1 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >2 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >3 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >4 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >5 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >6 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >7 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >8 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer >9 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 10';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 11';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 12';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 13';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 14';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 15';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 16 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 17 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 18 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 19 ';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 20';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 21';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 22';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  'Layer 23|';
    Value:     0;
    ParamType: _Explicite;
    Values:    Pens),
   (DescrStr:  '>Pen 1 Width (m)';
    Value:     300;
    ParamType: _Numeric;
    MinVal:    50;
    MaxVal:    3000),
   (DescrStr:  'P>en 2 Width (m)';
    Value:     500;
    ParamType: _Numeric;
    MinVal:    50;
    MaxVal:    3000),
   (DescrStr:  'Other Pens >Width';     // (m)
    Value:     700;
    ParamType: _Numeric;
    MinVal:    50;
    MaxVal:    3000),
   (DescrStr:  '>Overlap (m)';
    Value:     100;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    1000),
   (DescrStr:  '>Fill Elements';
    Value:     Ord (true);
    ParamType: _Explicite;
    Values:    '>No|>Yes'),
   (DescrStr:  'Pen >Velocity (cm/s)';
    Value:     10;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    200));

FUNCTION GetDescrPtr440: DescrPtr_T;
begin
  Result := @ DriverDescr;
end;

FUNCTION GetParamPtr (ParamNumber: integer): ParamPtr_T;
begin
  Result := @ Params [ParamIndex_T (ParamNumber)];
end;

PROCEDURE SetParamValue (ParamNumber: integer; ParamValue: integer);
begin
  Params [ParamIndex_T (ParamNumber)].Value := ParamValue;
end;

// -----------------------------------------------------------------------------

VAR
  CurrentX, CurrentY: DriverUnits_T;
  CurrentPen: integer;
  PenWidth, Overlap: integer;           // plotter units

function ChordAngle (r: integer): integer;
begin
  if r < 20 then
    ChordAngle := 45
  else if r < 40 then
    ChordAngle := 15
  else
    ChordAngle := 10;
end;

procedure PenUp;
begin
  WriteStr ('PU;');
end;

procedure SelectPen (PenNumber: integer);
  var Width: integer;
begin
  if PenNumber <> CurrentPen then begin
    PenUp;
    WriteStr ('SP' + IntStr (PenNumber) + ';'^M^J);
    case PenNumber of
      1:   Width := Params [Pen1Width].Value;
      2:   Width := Params [Pen2Width].Value;
      else Width := Params [OthersWidth].Value;
    end;
    CurrentPen := PenNumber;

    PenWidth := Round (Width / 1000
                     * DriverDescr.XDividend / DriverDescr.Divisor);
    Overlap  := Round (Params [OverlapPar].Value / 1000
                     * DriverDescr.XDividend / DriverDescr.Divisor);
    if Overlap >= PenWidth then Overlap := PenWidth - 1;
  end;
end;

procedure Circle (x, y, r: integer);
begin
{ if InOutRes <> 0 then Exit; }
  if r <= 0 then
    WriteStr ('PA' + IntStr (x) +     ',' + IntStr (y) + ';PD;'^M^J)
  else
    WriteStr ('PA' + IntStr (x + r) + ',' + IntStr (y) + ';PD;'
            + 'AA' + IntStr (x)     + ',' + IntStr (y) + ',360,'
            + IntStr (ChordAngle (r)) + ';'^M^J);
  CurrentX := x;   CurrentY := y;
end;

procedure Oval (x1, y1, x2, y2, r: integer);
  var dx, dy: integer;
begin
{ if InOutRes <> 0 then Exit; }
  if (x1 = x2) and (y1 = y2) then
    Circle (x1, y1, r)
  else if r <= 0 then begin
    WriteStr ('PA' + IntStr (x1) + ',' + IntStr (y1) + ';' 
            + 'PD' + IntStr (x2) + ',' + IntStr (y2) + ';'^M^J);
    CurrentX := x2;   CurrentY := y2;
  end
  else begin
    dx := Round (Int (r) * Int (y2 - y1) / Sqrt (Sqr (Int (x2 - x1)) + Sqr (Int (y2 - y1))));
    if y1 <> y2 then
      dy := Round (- Int (x2 - x1) * Int (dx) / Int (y2 - y1))
    else
      if x1 < x2 then dy := - r else dy := r;
    WriteStr ('PA' + IntStr (x1 + dx) + ',' + IntStr (y1 + dy) + ';'
            + 'PD' + IntStr (x2 + dx) + ',' + IntStr (y2 + dy) + ';'
            + 'AA' + IntStr (x2) + ',' + IntStr (y2) + ',180,' + IntStr (ChordAngle (r)) + ';'
            + 'PD' + IntStr (x1 - dx) + ',' + IntStr (y1 - dy) + ';'
            + 'AA' + IntStr (x1) + ',' + IntStr (y1) + ',180,' + IntStr (ChordAngle (r)) + ';'^M^J);
    CurrentX := x1;   CurrentY := y1;
  end;
end {Oval};

procedure Rectangle (x, y, w, h: integer);
begin
{ if InOutRes <> 0 then Exit; }
  if (w < 0) and (h < 0) then
    WriteStr ('PA' + IntStr (x) + ',' + IntStr (y) + ';PD;'^M^J)
  else if (w < 0) then
    WriteStr ('PA' + IntStr (x) + ',' + IntStr (y - h) + ';'
            + 'PD' + IntStr (x) + ',' + IntStr (y + h) + ';'^M^J)
  else if (h < 0) then
    WriteStr ('PA' + IntStr (x - w) + ',' + IntStr (y) + ';'
            + 'PD' + IntStr (x + w) + ',' + IntStr (y) + ';'^M^J)
  else
    WriteStr ('PA' + IntStr (x - w) + ',' + IntStr (y - h) + ';'
            + 'PD' + IntStr (x + w) + ',' + IntStr (y - h) + ','
                   + IntStr (x + w) + ',' + IntStr (y + h) + ','
                   + IntStr (x - w) + ',' + IntStr (y + h) + ','
                   + IntStr (x - w) + ',' + IntStr (y - h) + ';'^M^J);
  CurrentX := x;   CurrentY := y;
end {Rectangle};

procedure FillCircle (x, y, r: integer);
begin
  repeat
    r := r - Round (PenWidth / 2);
    Circle (x, y, r);
    r := r - Round (PenWidth / 2 - Overlap);
  until r <= 0;
end {FillCircle};

procedure FillOval (x1, y1, x2, y2, r: integer);
begin
  repeat
    r := r - Round (PenWidth / 2);
    Oval (x1, y1, x2, y2, r);
    r := r - Round (PenWidth / 2 - Overlap);
  until r <= 0
end {FillOval};

procedure FillRectangle (x, y, w, h: integer);
begin
  repeat
    w := w - Round (PenWidth / 2);
    h := h - Round (PenWidth / 2);
    Rectangle (x, y, w, h);
    w := w - Round (PenWidth / 2 - Overlap);
    h := h - Round (PenWidth / 2 - Overlap);
  until (w <= 0) or (h <= 0)
end {FillRectangle};

// -----------------------------------------------------------------------------

PROCEDURE OpenEquip (WriteProc: WriteProc_T; X0, Y0, X1, Y1: DriverUnits_T);
begin
  Write := WriteProc;
  WriteStr ('IN;');
  if Params [PenVelocity].Value > 0 then
    WriteStr ('VS' + IntStr (Params [PenVelocity].Value) + ';');
  CurrentX := -MaxInt;   CurrentY := -MaxInt;
  CurrentPen := 0;
end;

PROCEDURE Comment (const CommentString: string);
begin
end;

PROCEDURE OpenLayer (Layer: integer; Color: integer = 0);
begin
  if Layer <= Ord (Layer23) then
    SelectPen (Params [ParamIndex_T (Layer)].Value + 1);
end;

PROCEDURE DrawLine (X0, Y0, X1, Y1: DriverUnits_T; ToolNumber: ToolNumber_T);
  var X, Y, R: DriverUnits_T;

  function Distance (dx, dy: Extended): Extended;
  begin
    Result := Sqrt (Sqr (dx) + Sqr (dy));
  end;

begin
  if Distance (X0 - CurrentX, Y0 - CurrentY) > Distance (X1 - CurrentX, Y1 - CurrentY)
  then begin
    X  := X0;   Y  := Y0;
    X0 := X1;   Y0 := Y1;
    X1 := X;    Y1 := Y;
  end;
  R := WorkToolTable [ToolNumber].Width div 2;
  if Boolean (Params [FillElements].Value) then begin
    if Distance (X0 - CurrentX, Y0 - CurrentY) > R - PenWidth / 2 then PenUp;
    FillOval (X0, Y0, X1, Y1, R);
  end
  else begin
    PenUp;
    Oval     (X0, Y0, X1, Y1, R);
  end
end {DrawLine};

PROCEDURE FlashPad (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
  var w, h: DriverUnits_T;
begin
  PenUp;
  w := WorkToolTable [ToolNumber].Width  div 2;
  h := WorkToolTable [ToolNumber].Height div 2;
  if WorkToolTable [ToolNumber].Shape = SquareTool then
    if Boolean (Params [FillElements].Value) then
      FillRectangle (X, Y, w, h)
    else
      Rectangle     (X, Y, w, h)
  else if WorkToolTable [ToolNumber].Shape = CircleTool then begin
    if Boolean (Params [FillElements].Value) then
      if w > h then
        FillOval (X - (w - h), Y, X + (w - h), Y, h)
      else
        FillOval (X, Y - (h - w), X, Y + (h - w), w)
    else
      if w > h then
        Oval     (X - (w - h), Y, X + (w - h), Y, h)
      else
        Oval     (X, Y - (h - w), X, Y + (h - w), w);
  end;
end {FlashPad};

PROCEDURE CloseEquip;
begin
  WriteStr ('PU0,0;SP0;'^M^J);
end;

EXPORTS
  GetDescrPtr440,
  GetParamPtr,
  SetParamValue,
  OpenEquip,
  Comment,
  OpenLayer,
  DrawLine,
  FlashPad,
  CloseEquip;

BEGIN
END.
