(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2004 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  funkce GetDescrPtr pejmenovna pro rozlien verz na GetDescrPtr440 (P93)
2)  do funkce OpenLayer doplnn parametr Color (P93)
3)  poet vrstev v menu rozen na 24 (P94)
4)  pidny parametry Color Saturation a Color Brightness (P94)
5)  ve vstupnm souboru definovna makra pro nastaven barev (P94)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

LIBRARY PostScript;

USES DrvTypes, DLL_Util;

TYPE
  ParamIndex_T = (
    Layer0,
    Layer1,
    Layer2,
    Layer3,
    Layer4,
    Layer5,
    Layer6,
    Layer7,
    Layer8,
    Layer9,
    Layer10,
    Layer11,
    Layer12,
    Layer13,
    Layer14,
    Layer15,
    Layer16,
    Layer17,
    Layer18,
    Layer19,
    Layer20,
    Layer21,
    Layer22,
    Layer23,
    ColorSaturation,
    ColorBrightness,
    DarkGrayShade,
    LightGrayShade,
    HoleDiameter);
  Shade_T = (Black, DarkGray, LightGray, White);

CONST
  ToolCount = 0;
  DriverDescr: DriverDescr_T = (
    Name:         'PostScript 4.40  PH 2004';
    MajorVersion: 4;
    MinorVersion: 0;
    Capabilities: [DrawLines, DrawArcs, FlashPads, UserTools, ConfigTools];
    NoOfParams:   Ord (High (ParamIndex_T)) + 1;
    FilesName:    'PostScr';
    TargetExt:    '.PS';
    NoOfTools:    ToolCount;
    InitialTools: nil;
    MaxNoOfTools: MaxToolCount;
    ToolTablePtr: @ WorkToolTable;
    X0:           0;
    Y0:           0;
    X1:           800;
    Y1:           600;
    XDividend:    1000;
    YDividend:    1000;
    Divisor:      1);

  Colors = 'Blac>k|>Dark Gray|>Light Gray|>White|>Yellow|>Green|>Cyan|>Blue|>Magenta|>Red';

  Params: array [ParamIndex_T] of ParamDescr_T = (
   (DescrStr:  'Layer >0 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >1 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >2 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >3 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >4 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >5 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >6 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >7 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >8 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >9 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 10';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 11';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 12';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 13';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 14';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 15';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 16 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 17 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 18 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 19 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 20';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 21';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 22';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 23|';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Color >Saturation (%)';
    Value:     50;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  'Color >Brightness (%)';
    Value:     75;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  '>Dark Gray Shade (%)';
    Value:     36;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  '>Light Gray Shade (%)|';
    Value:     12;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  '>Hole Diameter (m)';
    Value:     300;
    ParamType: _Numeric;
    MinVal:    -2000;   // zporn hodnota znamen otvory v libovolnch pjecch bodech,
    MaxVal:    2000));  // kladn jen v kulatch

FUNCTION GetDescrPtr440: DescrPtr_T;
begin
  Result := @ DriverDescr;
end;

FUNCTION GetParamPtr (ParamNumber: integer): ParamPtr_T;
begin
  Result := @ Params [ParamIndex_T (ParamNumber)];
end;

PROCEDURE SetParamValue (ParamNumber: integer; ParamValue: integer);
begin
  Params [ParamIndex_T (ParamNumber)].Value := ParamValue;
end;

// -----------------------------------------------------------------------------

function PercentStr (p: integer): string;
begin
  Str (p / 100: 1: 2, Result);
end;

procedure DefineColors;
  const Shades: array [Shade_T] of integer = (0, 0, 0, 100);
  var Color: integer;
begin
  Shades [DarkGray]  := 100 - Params [DarkGrayShade].Value;
  Shades [LightGray] := 100 - Params [LightGrayShade].Value;
  for Color := 0 to 9 do
    if Shade_T (Color) <= White then
      WriteStr ('/C' + IntStr (Color) + ' {'
                     + PercentStr (Shades [Shade_T (Color)])
                     + ' setgray} def'^M^J)
    else
      WriteStr ('/C' + IntStr (Color) + ' {'
                     + IntStr (Color - Ord (White)) + ' 6 div '
                     + PercentStr (Params [ColorSaturation].Value) + ' '
                     + PercentStr (Params [ColorBrightness].Value)
                     + ' sethsbcolor} def'^M^J);
end;

VAR CurrentWidth: DriverUnits_T;

PROCEDURE OpenEquip (WriteProc: WriteProc_T; X0, Y0, X1, Y1: DriverUnits_T);
begin
  Write := WriteProc;
  WriteStr ('% PostScript Level 2 file generated by FORMICA 4.40'^M^J
          + ^M^J
          + '/W {setlinewidth} def'^M^J
          + '/M {moveto} def'^M^J
          + '/L {lineto stroke} def'^M^J
          + '/A {arc stroke} def'^M^J
          + '/C {2 div 0 360 arc fill} def'^M^J
          + '/R {rectfill} def'^M^J
          + '/D {2 div 0 360 arc stroke} def'^M^J
          + ^M^J);
  DefineColors;
  WriteStr (^M^J
          + '1 setlinecap'^M^J
          + '1 setlinejoin'^M^J
          + ^M^J
          + '[0.0028346456693 0 0 0.0028346456693 0 0] concat'^M^J
       (* + '[3 0 0 3 0 0] concat'^M^J +  (* pro ladeni *)
          + ^M^J);
  CurrentWidth := MaxLongInt;
end;

PROCEDURE Comment (const CommentString: string);
begin
  WriteStr (^M^J'% ' + CommentString + ^M^J^M^J);
end;

procedure SetColor (Color: integer);
begin
  WriteStr ('C' + IntStr (Color));
end;

VAR LayerColor: integer;

PROCEDURE OpenLayer (Layer: integer; Color: integer = 0);
begin
  WriteStr (^M^J + '% Layer ' + IntStr (Layer) + ^M^J^M^J);
  if Layer <= Ord (Layer23) then begin
    LayerColor := Params [ParamIndex_T (Layer)].Value;
    SetColor (LayerColor);
    WriteStr (^M^J^M^J);
  end;
end;

procedure ChangeLineWidth (Width: DriverUnits_T);
begin
  if Width <> CurrentWidth then
    WriteStr (IntStr (Width) + ' W'^M^J);
  CurrentWidth := Width;
end;

procedure LineSegment (X0, Y0, X1, Y1: DriverUnits_T);
begin
  WriteStr (IntStr (X0) + ' ' + IntStr (Y0) + ' M '
          + IntStr (X1) + ' ' + IntStr (Y1) + ' L'^M^J);
end;

PROCEDURE DrawLine (X0, Y0, X1, Y1: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  ChangeLineWidth (WorkToolTable [ToolNumber].Width);
  LineSegment (X0, Y0, X1, Y1);
end;

PROCEDURE DrawArc (X, Y, R: DriverUnits_T; Angle1, Angle2: integer; ToolNumber: ToolNumber_T);
  var Angle: integer;
begin
  ChangeLineWidth (WorkToolTable [ToolNumber].Width);
  if Angle1 > Angle2 then begin
    Angle := Angle1;   Angle1 := Angle2;   Angle2 := Angle;
  end;
  WriteStr (IntStr (X) + ' '
          + IntStr (Y) + ' '
          + IntStr (R) + ' '
          + IntStr (Angle1) + ' '
          + IntStr (Angle2) + ' A'^M^J);
end;

PROCEDURE FlashPad (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
  var Radius, Length: DriverUnits_T;

  procedure PadHole ({X, Y: DriverUnits_T;} Diameter: Thousandth_T);
  begin
    SetColor (3 { = White} );
    WriteStr (' ' + IntStr (X)
            + ' ' + IntStr (Y)
            + ' ' + IntStr (Diameter) + ' C ');
    SetColor (LayerColor);
    WriteStr (^M^J);
  end;

begin {FlashPad}
  with WorkToolTable [ToolNumber] do
    case Shape of
      CircleTool:   begin
                      Length := (Width - Height) div 2;
                      if Length = 0 then begin
                        WriteStr (IntStr (X) + ' '
                                + IntStr (Y) + ' '
                                + IntStr (Width) + ' C'^M^J);
                        with Params [HoleDiameter] do
                          if Value <> 0 then PadHole (Abs (Value));
                      end
                      else if Length < 0 then begin
                        ChangeLineWidth (Width);
                        LineSegment (X, Y - Length, X, Y + Length);
                        with Params [HoleDiameter] do
                          if Value < 0 then PadHole (Abs (Value));
                      end
                      else {if Length > 0 then} begin
                        ChangeLineWidth (Height);
                        LineSegment (X - Length, Y, X + Length, Y);
                        with Params [HoleDiameter] do
                          if Value < 0 then PadHole (Abs (Value));
                      end;
                    end;
      SquareTool:   begin
                      WriteStr (IntStr (X - Width  div 2) + ' '
                              + IntStr (Y - Height div 2) + ' '
                              + IntStr (Width)            + ' '
                              + IntStr (Height) + ' R'^M^J);
                      with Params [HoleDiameter] do
                        if Value < 0 then PadHole (Abs (Value));
                    end;
      AnnulusTool:  begin
                      ChangeLineWidth (Height);
                      WriteStr (IntStr (X) + ' '
                              + IntStr (Y) + ' '
                              + IntStr (Width + Height) + ' D'^M^J);
                    end;
      ThermalTool:  begin
                      Radius := (Width + Height) div 2;
                      Length := Radius - Round (SqRt (2) * Height);
                      ChangeLineWidth (Height);
                      LineSegment (X - Length, Y - Radius, X + Length, Y - Radius);
                      LineSegment (X - Length, Y + Radius, X + Length, Y + Radius);
                      LineSegment (X - Radius, Y - Length, X - Radius, Y + Length);
                      LineSegment (X + Radius, Y - Length, X + Radius, Y + Length);
                    end;
    end;
end {FlashPad};

PROCEDURE DrillHole (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  WriteStr (IntStr (X) + ' '
          + IntStr (Y) + ' '
          + IntStr (WorkToolTable [ToolNumber].Width) + ' C'^M^J);
end;

PROCEDURE CloseEquip;
begin
  WriteStr (^M^J'showpage'^M^J);
end;

EXPORTS
  GetDescrPtr440,
  GetParamPtr,
  SetParamValue,
  OpenEquip,
  Comment,
  OpenLayer,
  DrawLine,
  DrawArc,
  FlashPad,
  DrillHole,
  CloseEquip;

BEGIN
END.
