(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2007 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  funkce GetDescrPtr pejmenovna pro rozlien verz na GetDescrPtr440 (P93)
2)  do funkce OpenLayer doplnn parametr Color (P93)
3)  poet vrstev v menu rozen na 24 (P94)
4)  pidny parametry Color Saturation a Color Brightness (P94)
5)  ve vstupnm souboru definovna makra pro nastaven barev (P94)
6)  knihovna odvozena od PostScr.pas (P95)
7)  monost generovat pkaz /PageSize nebo dal transforman matici (P95)
8)  po odstrnkovn nov nastavena barva a ka ry (P98)
9)  doplnn parametr pro volbu typu pad s otvory (P98)
10) doplnny HTML barvy a barva pro vyplovn otvor (P98)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

LIBRARY PostScrX;

USES DrvTypes, DLL_Util;

TYPE
  ParamIndex_T = (
    Layer0,
    Layer1,
    Layer2,
    Layer3,
    Layer4,
    Layer5,
    Layer6,
    Layer7,
    Layer8,
    Layer9,
    Layer10,
    Layer11,
    Layer12,
    Layer13,
    Layer14,
    Layer15,
    Layer16,
    Layer17,
    Layer18,
    Layer19,
    Layer20,
    Layer21,
    Layer22,
    Layer23,
    Holes,
    DarkGrayShade,
    LightGrayShade,
    ColorSaturation,
    ColorBrightness,
    PadSaturation,
    PadBrightness,
    HoleType,
    HoleDiameter,
    TwoPages,
    Mode);
  Shade_T = (Black, DarkGray, LightGray, White);
  Color_T = (_Black, _DarkGray, _LightGray, _White, Yellow, Green, Cyan, Blue, Magenta, Red,
             Gold, Tan, Khaki, OliveDrab, LimeGreen, Turquoise, RoyalBlue, BlueViolet, DarkOrchid,
             Plum, PaleVioletRed, DeepPink, Crimson, RosyBrown, Brown, Chocolate, DarkOrange, Orange);
  Hole_T  = (AnyShape, CircleAndOval, CircleOnly, NoShape);
  Mode_T = (FitPage, PosLL, PosLC, PosLR, PosCL, PosCC, PosCR, PosUL, PosUC, PosUR);

CONST
  ToolCount = 0;
  DriverDescr: DriverDescr_T = (
    Name:         'PostScript 4.40  PH 2007';
    MajorVersion: 4;
    MinorVersion: 0;
    Capabilities: [DrawLines, DrawArcs, FlashPads, UserTools, ConfigTools];
    NoOfParams:   Ord (High (ParamIndex_T)) + 1;
    FilesName:    'PostScrX';
    TargetExt:    '.PS';
    NoOfTools:    ToolCount;
    InitialTools: nil;
    MaxNoOfTools: MaxToolCount;
    ToolTablePtr: @ WorkToolTable;
    X0:           10;
    Y0:           10;
    X1:           200;
    Y1:           287;
    XDividend:    1000;
    YDividend:    1000;
    Divisor:      1);

  Colors = 'Blac>k|>Dark Gray|>Light Gray|>White|>Yellow|>Green|>Cyan|>Blue|>Magenta|>Red|'
         + 'Gold|Tan|Khaki|Olive Drab|Lime Green|Turquoise|Royal Blue|Blue Violet|Dark Orchid|'
         + 'Plum|Pale Violet Red|Deep Pink|Crimson|Rosy Brown|Brown|Chocolate|Dark Orange|Orange';
  NoOfColors = Ord (High (Color_T)) + 1;

  Params: array [ParamIndex_T] of ParamDescr_T = (
   (DescrStr:  'Layer >0 ';
    Value:     Ord (Green);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >1 ';
    Value:     Ord (Green);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >2 ';
    Value:     Ord (Green);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >3 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >4 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >5 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >6 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >7 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >8 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer >9 ';
    Value:     Ord (Red);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 10';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 11';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 12';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 13';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 14';
    Value:     Ord (Cyan);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 15';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 16 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 17 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 18 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 19 ';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 20';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 21';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 22';
    Value:     Ord (Magenta);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Layer 23';
    Value:     Ord (Black);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  'Holes|';
    Value:     Ord (White);
    ParamType: _Explicite;
    Values:    Colors),
   (DescrStr:  '>Dark Gray Shade (%)';
    Value:     36;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  '>Light Gray Shade (%)';
    Value:     12;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  'Color >Saturation (%)';
    Value:     30;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    100),
   (DescrStr:  'Color >Brightness (%)|';
    Value:     80;
    ParamType: _Numeric;
    MinVal:    30;
    MaxVal:    100),
   (DescrStr:  '>Pad Rel. Saturation (%)';
    Value:     30;
    ParamType: _Numeric;
    MinVal:    -90;
    MaxVal:    90),
   (DescrStr:  'Pad >Rel. Brightness (%)|';
    Value:     -10;
    ParamType: _Numeric;
    MinVal:    -90;
    MaxVal:    90),
   (DescrStr:  'Hole >in';
    Value:     Ord (CircleAndOval);
    ParamType: _Explicite;
    Values:    '>Any Pad Shape|Circle && >Oval|>Circle Only|>No Shape'),
   (DescrStr:  '>Hole Diameter (m)|';
    Value:     300;
    ParamType: _Numeric;
    MinVal:    0;
    MaxVal:    2000),   
   (DescrStr:  '>Two Pages';
    Value:     Ord (True);
    ParamType: _Explicite;
    Values:    '>Disabled|>Enabled'),
   (DescrStr:  '>Mode';
    Value:     Ord (FitPage);
    ParamType: _Explicite;
    Values:    '>Fit Page to Board (0)|Lower Left (>1)|Lower Center (>2)|Lower Right (>3)|'
                                    + 'Center Left (>4)|Page >Center (5)|Center Right (>6)|'
                                    + 'Upper Left (>7)|Upper Center (>8)|Upper Right (>9)'));

FUNCTION GetDescrPtr440: DescrPtr_T;
begin
  Result := @ DriverDescr;
end;

FUNCTION GetParamPtr (ParamNumber: integer): ParamPtr_T;
begin
  Result := @ Params [ParamIndex_T (ParamNumber)];
end;

PROCEDURE SetParamValue (ParamNumber: integer; ParamValue: integer);
begin
  Params [ParamIndex_T (ParamNumber)].Value := ParamValue;
end;

// --- COLORS ------------------------------------------------------------------

TYPE
  HtmlColor_T = record
                  Name: string [20];
                  RGB:  integer;
                end;
  HtmlColors_T = array [Succ (Red) .. High (Color_T)] of HtmlColor_T;

CONST
  HtmlColors: HtmlColors_T = (
    (Name: 'Gold';          RGB: $FFD700),
    (Name: 'Tan';           RGB: $D2B48C),
    (Name: 'Khaki';         RGB: $F0E68C),
    (Name: 'OliveDrab';     RGB: $6B8E23),
    (Name: 'LimeGreen';     RGB: $32CD32),
    (Name: 'Turquoise';     RGB: $40E0D0),
    (Name: 'RoyalBlue';     RGB: $4169E1),
    (Name: 'BlueViolet';    RGB: $8A2BE2),
    (Name: 'DarkOrchid';    RGB: $9932CC),
    (Name: 'Plum';          RGB: $DDA0DD),
    (Name: 'PaleVioletRed'; RGB: $DB7093),
    (Name: 'DeepPink';      RGB: $FF1493),
    (Name: 'Crimson';       RGB: $DC143C),
    (Name: 'RosyBrown';     RGB: $BC8F8F),
    (Name: 'Brown';         RGB: $A52A2A),
    (Name: 'Chocolate';     RGB: $D2691E),
    (Name: 'DarkOrange';    RGB: $FF8C00),
    (Name: 'Orange';        RGB: $FFA500)
  );

function PercentStr (p: integer): string;
begin
  if p < 0 then
    Result := '0'
  else if p > 100 then
    Result := '1'
  else
    Str (p / 100: 1: 2, Result);
end;

procedure DefineColors;
  const Shades: array [Shade_T] of integer = (0, 0, 0, 100);
  var Color: integer;
begin
  Shades [DarkGray]  := 100 - Params [DarkGrayShade].Value;
  Shades [LightGray] := 100 - Params [LightGrayShade].Value;
  for Color := 0 to Ord (High (Color_T)) do
    if Shade_T (Color) <= White then
      WriteStr ('/C' + IntStr (Color) + ' {'
                     + PercentStr (Shades [Shade_T (Color)])
                     + ' setgray} def'^M^J
              + '/P' + IntStr (Color) + ' {'
                     + PercentStr (Shades [Shade_T (Color)]
                                 + Params [PadBrightness].Value)
                     + ' setgray} def'^M^J)
    else if Color_T (Color) <= Red then
      WriteStr ('/C' + IntStr (Color) + ' {'
                     + IntStr (Color - Ord (White)) + ' 6 div '
                     + PercentStr (Params [ColorSaturation].Value) + ' '
                     + PercentStr (Params [ColorBrightness].Value)
                     + ' sethsbcolor} def'^M^J
              + '/P' + IntStr (Color) + ' {'
                     + IntStr (Color - Ord (White)) + ' 6 div '
                     + PercentStr (Params [ColorSaturation].Value
                                 + Params [PadSaturation].Value) + ' '
                     + PercentStr (Params [ColorBrightness].Value
                                 + Params [PadBrightness].Value)
                     + ' sethsbcolor} def'^M^J)
    else with HtmlColors [Color_T (Color)] do
      WriteStr ('/' + Name + Copy ('                ', 1, 14 - Length (Name)) + ' {'
                    + ARIntStr ((RGB shr 16) and $FF, 3) + ' 255 div '
                    + ARIntStr ((RGB shr  8) and $FF, 3) + ' 255 div '
                    + ARIntStr ( RGB         and $FF, 3) + ' 255 div setrgbcolor} def'^M^J);
  WriteStr (''^M^J);
end {DefineColors};

VAR CurrentColor, LayerColor: integer;

procedure SetColor (Color: integer; SameLine: Boolean = true);
begin
  if Color <> CurrentColor then begin
    if Color_T (Color mod NoOfColors) <= Red then
      if Color < NoOfColors then
        WriteStr ('C' + IntStr (Color))
      else
        WriteStr ('P' + IntStr (Color - NoOfColors))
    else
      WriteStr (HtmlColors [Color_T (Color mod NoOfColors)].Name);
    CurrentColor := Color;
    if SameLine then WriteStr (' ') else WriteStr (''^M^J^M^J);
  end;
end;

// -----------------------------------------------------------------------------

VAR
  AnyPage, NewPage: Boolean;
  CurrentWidth: DriverUnits_T;

procedure OutputOffset (SpareWidth, SpareHeight: DriverUnits_T);
  var OfsX, OfsY: DriverUnits_T;
begin
  case Mode_T (Params [ParamIndex_T (Mode)].Value) of
    FitPage,
    PosLL,
    PosCL,
    PosUL: OfsX := 0;
    PosLC,
    PosCC,
    PosUC: OfsX := SpareWidth div 2;
    PosLR,
    PosCR,
    PosUR: OfsX := SpareWidth;
  end;
  case Mode_T (Params [ParamIndex_T (Mode)].Value) of
    FitPage,
    PosLL,
    PosLC,
    PosLR: OfsY := 0;
    PosCL,
    PosCC,
    PosCR: OfsY := SpareHeight div 2;
    PosUL,
    PosUC,
    PosUR: OfsY := SpareHeight;
  end;
  if (OfsX <> 0) or (OfsY <> 0) then
    WriteStr ('    [1 0 0 1 ' + IntStr (OfsX)
                        + ' ' + IntStr (OfsY) + '] concat'^M^J);
end;

PROCEDURE OpenEquip (WriteProc: WriteProc_T; X0, Y0, X1, Y1: DriverUnits_T);
begin
  Write := WriteProc;
  WriteStr ('% PostScript Level 2 file generated by FORMICA 4.40'^M^J^M^J);
  WriteStr ('/S {72 25400 div dup scale'^M^J);  // zavede 1 m jako uivatelskou jednotku (DriverUnits_T)
  OutputOffset ((DriverDescr.X1 - DriverDescr.X0 - 2) * DriverDescr.XDividend div DriverDescr.Divisor
              - (X1 - X0),
                (DriverDescr.Y1 - DriverDescr.Y0 - 2) * DriverDescr.YDividend div DriverDescr.Divisor
              - (Y1 - Y0));
  WriteStr ('    1 setlinecap'^M^J'    1 setlinejoin} def'^M^J
          + '/W {setlinewidth} def'^M^J
          + '/M {moveto} def'^M^J
          + '/L {lineto stroke} def'^M^J
          + '/A {arc stroke} def'^M^J
          + '/C {2 div 0 360 arc fill} def'^M^J
          + '/R {rectfill} def'^M^J
          + '/D {2 div 0 360 arc stroke} def'^M^J
          + ''^M^J);
  DefineColors;

  if Mode_T (Params [ParamIndex_T (Mode)].Value) = FitPage then
    WriteStr ('<< /PageSize [' + IntStr ((X1 + X0) * 72 div 25400)      // pevzato z ps4pdf
                         + ' ' + IntStr ((Y1 + Y0) * 72 div 25400)      // X0 a Y0 jsou chpny jako okraj a uity i na druh stran
                         + '] >> setpagedevice'^M^J^M^J);

  WriteStr (''^M^J'S'^M^J);     // nastav mtko, offset a zakonen ar

  AnyPage := false;     // dn strnka dosud nevytitna
  NewPage := false;     // nebylo odstrnkovno
  CurrentColor := MaxInt;
  CurrentWidth := MaxInt;
end {OpenEquip};

PROCEDURE Comment (const CommentString: string);
begin
  WriteStr (''^M^J'% ' + CommentString + ''^M^J^M^J);
end;

PROCEDURE OpenLayer (Layer: integer; Color: integer = 0);
begin
  if Boolean (Params [TwoPages].Value) and (Layer >= 12) and not NewPage then begin
    if AnyPage then     // odstrnkuje se pouze tehdy, byla-li njak strnka ji vytitna
      WriteStr (''^M^J'showpage'^M^J^M^J'S'^M^J^M^J);   // odstrnkuje, nastav mtko, offset a zakonen ar
    NewPage := true;    // v obou ppadech vylou dal odstrnkovn
  end;
  AnyPage := true;

  WriteStr (''^M^J + '% Layer ' + IntStr (Layer) + ''^M^J^M^J);

  CurrentColor := MaxInt;       // vynut nov nastaven barvy
  CurrentWidth := MaxInt;       // a ky

  if Layer <= Ord (Holes) then begin
    LayerColor := Params [ParamIndex_T (Layer)].Value;
    SetColor (LayerColor, false);
  end;
end {OpenLayer};

procedure ChangeLineWidth (Width: DriverUnits_T);
begin
  if Width <> CurrentWidth then
    WriteStr (IntStr (Width) + ' W'^M^J);
  CurrentWidth := Width;
end;

procedure LineSegment (X0, Y0, X1, Y1: DriverUnits_T);
begin
  WriteStr (IntStr (X0) + ' ' + IntStr (Y0) + ' M '
          + IntStr (X1) + ' ' + IntStr (Y1) + ' L'^M^J);
end;

PROCEDURE DrawLine (X0, Y0, X1, Y1: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  SetColor (LayerColor);
  ChangeLineWidth (WorkToolTable [ToolNumber].Width);
  LineSegment (X0, Y0, X1, Y1);
end;

PROCEDURE DrawArc (X, Y, R: DriverUnits_T; Angle1, Angle2: integer; ToolNumber: ToolNumber_T);
  var Angle: integer;
begin
  SetColor (LayerColor);
  ChangeLineWidth (WorkToolTable [ToolNumber].Width);
  if Angle1 > Angle2 then begin
    Angle := Angle1;   Angle1 := Angle2;   Angle2 := Angle;
  end;
  WriteStr (IntStr (X) + ' '
          + IntStr (Y) + ' '
          + IntStr (R) + ' '
          + IntStr (Angle1) + ' '
          + IntStr (Angle2) + ' A'^M^J);
end;

PROCEDURE FlashPad (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
  var Radius, Length: DriverUnits_T;

  procedure PadHole ({X, Y: DriverUnits_T;} Diameter: Thousandth_T);
  begin
    if Diameter > 0 then begin
      SetColor (Params [Holes].Value);
      WriteStr (' ' + IntStr (X)
              + ' ' + IntStr (Y)
              + ' ' + IntStr (Diameter) + ' C '^M^J);
    end;
  end;

begin {FlashPad}
  SetColor (LayerColor + NoOfColors);
  with WorkToolTable [ToolNumber] do
    case Shape of
      CircleTool:   begin
                      Length := (Width - Height) div 2;
                      if Length = 0 then begin
                        WriteStr (IntStr (X) + ' '
                                + IntStr (Y) + ' '
                                + IntStr (Width) + ' C'^M^J);
                        if Hole_T (Params [HoleType].Value) in [AnyShape, CircleAndOval, CircleOnly] then
                          PadHole (Params [HoleDiameter].Value);
                      end
                      else begin
                        if Length < 0 then begin
                          ChangeLineWidth (Width);
                          LineSegment (X, Y - Length, X, Y + Length);
                        end
                        else begin
                          ChangeLineWidth (Height);
                          LineSegment (X - Length, Y, X + Length, Y);
                        end;
                        if Hole_T (Params [HoleType].Value) in [AnyShape, CircleAndOval] then
                          PadHole (Params [HoleDiameter].Value);
                      end;
                    end;
      SquareTool:   begin
                      WriteStr (IntStr (X - Width  div 2) + ' '
                              + IntStr (Y - Height div 2) + ' '
                              + IntStr (Width)            + ' '
                              + IntStr (Height) + ' R'^M^J);
                      if Hole_T (Params [HoleType].Value) in [AnyShape] then
                        PadHole (Params [HoleDiameter].Value);
                    end;
      AnnulusTool:  begin
                      ChangeLineWidth (Height);
                      WriteStr (IntStr (X) + ' '
                              + IntStr (Y) + ' '
                              + IntStr (Width + Height) + ' D'^M^J);
                    end;
      ThermalTool:  begin
                      Radius := (Width + Height) div 2;
                      Length := Radius - Round (SqRt (2) * Height);
                      ChangeLineWidth (Height);
                      LineSegment (X - Length, Y - Radius, X + Length, Y - Radius);
                      LineSegment (X - Length, Y + Radius, X + Length, Y + Radius);
                      LineSegment (X - Radius, Y - Length, X - Radius, Y + Length);
                      LineSegment (X + Radius, Y - Length, X + Radius, Y + Length);
                    end;
    end;
end {FlashPad};

PROCEDURE DrillHole (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  WriteStr (IntStr (X) + ' '
          + IntStr (Y) + ' '
          + IntStr (WorkToolTable [ToolNumber].Width) + ' C'^M^J);
end;

PROCEDURE CloseEquip;
begin
  WriteStr (''^M^J'showpage'^M^J);
end;

EXPORTS
  GetDescrPtr440,
  GetParamPtr,
  SetParamValue,
  OpenEquip,
  Comment,
  OpenLayer,
  DrawLine,
  DrawArc,
  FlashPad,
  DrillHole,
  CloseEquip;

BEGIN
END.
